package exemple.physiqueAvecInteraction;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;

import moteurJeu.moteur.DessinAbstract;

/**
 * permet de dessiner une balle
 * 
 * @author vincent.thomas@loria.fr
 *
 */
public class DessinPhysiqueInteraction implements DessinAbstract {

	/**
	 * Le jeu a rendre
	 */
	JeuPhysiqueInteraction jeu;

	/**
	 * creer un dessin physique en passant le jeu en parametre
	 * 
	 * @param j
	 *            jeu qu'on souhaite dessiner
	 */
	public DessinPhysiqueInteraction(JeuPhysiqueInteraction j) {
		this.jeu = j;
	}

	@Override
	/**
	 * il faut dessiner dans l'image le rendu
	 */
	public void dessiner(BufferedImage image) {
		// recuperation du crayon
		Graphics2D g = (Graphics2D) image.getGraphics();

		// dessin de la balle
		int x = (int) this.jeu.psX;
		int psY = (int) this.jeu.psY;

		// inversion axe y
		int y = 400 - psY;

		// dessin cercle
		g.setColor(Color.BLACK);
		int taille = 5;
		g.fillOval(x - taille, y - taille, 2 * taille, 2 * taille);

		// dessin sol
		g.setColor(Color.BLUE);
		g.drawLine(0, 400, 800, 400);
		g.drawLine(600, 0, 600, 400);

		// dessin texte
		g.drawString("appuyer sur <espace> pour sauter", 200, 50);

		// rendre crayon
		g.dispose();
	}

}
